You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 
 
 

868 lines
20 KiB

  1. #!/bin/bash
  2. # TODO: use tput
  3. # If not running interactively, don't do anything
  4. [[ $- != *i* ]] && return
  5. ##########################################
  6. null(){
  7. "$@" >/dev/null 2>&1
  8. }
  9. __try_exec(){
  10. type $1 >/dev/null 2>&1 && "$@"
  11. }
  12. ##########################
  13. # system type
  14. alias ismsys=false
  15. alias iscygwin=false
  16. alias iswindows=false
  17. alias isdarwin=false
  18. alias islinux=false
  19. alias with_coreutils=false # for mac
  20. case `uname` in
  21. (MINGW*) alias ismsys=true ;;
  22. (CYGWIN*) alias iscygwin=true ;;
  23. (Darwin*) alias isdarwin=true ;;
  24. (Linux*) alias islinux=true ;;
  25. esac
  26. null ls --version && alias with_coreutils=true
  27. ( ismsys || iscygwin ) && alias iswindows=true
  28. alias inbash=false
  29. alias inzsh=false
  30. if test -n "$BASH_VERSION"
  31. then
  32. alias inbash=true
  33. elif test -n "$ZSH_VERSION"
  34. then
  35. alias inzsh=true
  36. fi
  37. #################################
  38. __search_string(){
  39. # __search_string str1 str2
  40. # return 0 if str2 is found in str1
  41. expr "$1" : ".*$2.*" >/dev/null
  42. }
  43. if ! __search_string "$PATH" "$HOME/.local/bin"
  44. then
  45. PATH="${PATH}:${HOME}/.local/bin:$HOME/.local/lib/gems/bin"
  46. fi
  47. if ismsys && ! __search_string "$PATH" /c/mingw/bin
  48. then
  49. PATH="$PATH:/c/mingw/bin:/c/mingw/msys/1.0/bin"
  50. fi
  51. # # it is not so good
  52. # # http://archive.linux.or.jp/JF/JFdocs/Program-Library-HOWTO/shared-libraries.html
  53. # # http://superuser.com/questions/324613/installing-a-library-locally-in-home-directory-but-program-doesnt-recognize-it
  54. # without this ENV i cannot run tmux. another way is to use --disable-shared
  55. # when building tmux
  56. if ! __search_string "$LD_LIBRARY_PATH" "$HOME/.local/lib"
  57. then
  58. LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HOME/.local/lib"
  59. fi
  60. ##################################
  61. export LANG=ja_JP.UTF-8
  62. export LC_MESSAGES=C
  63. export TERMCAP="${TERMCAP}:vb="
  64. ismsys && export HOSTNAME
  65. export ENV=~/.shrc
  66. if false iswindows
  67. then
  68. export PAGER='tr -d \\r | less'
  69. else
  70. export PAGER="less"
  71. fi
  72. export LESS="-iRMX"
  73. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  74. if test -n "$_src_hilite_lp_path"
  75. then
  76. export LESSOPEN="| $_src_hilite_lp_path %s"
  77. fi
  78. if null type vim
  79. then
  80. export EDITOR=vim
  81. else
  82. export EDITOR=vi
  83. fi
  84. # export CDPATH=".:~"
  85. export VISUAL="$EDITOR"
  86. export GIT_PAGER="less -F"
  87. export GIT_EDITOR="$EDITOR"
  88. export GIT_MERGE_AUTOEDIT=no
  89. if test -n "$TMUX" && \
  90. echo $TERM | grep screen >/dev/null 2>&1 && \
  91. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  92. then
  93. TERM=screen-256color
  94. fi
  95. if test -z "$TMP"
  96. then
  97. if test -n "$TMPDIR"
  98. then
  99. export TMP=$TMPDIR
  100. elif test -n "$TEMP"
  101. then
  102. export TMP="$TEMP"
  103. else
  104. export TMP=/tmp
  105. fi
  106. fi
  107. export TMP="${TMP}/${USER}-tmp"
  108. export TEMP="$TMP"
  109. mkdir -p "$TMP"
  110. ! iswindows && null type stty && {
  111. stty stop undef # unbind C-s to stop displaying output
  112. # stty erase '^h'
  113. }
  114. if iswindows; then
  115. export USER=$USERNAME
  116. fi
  117. _tmux_prefs(){
  118. null type tmux || return 1
  119. tmux set -g mode-keys vi
  120. }
  121. if test -d ~/dbx
  122. then
  123. export CHIT_PATH="$HOME/dbx/.chit"
  124. fi
  125. #######################
  126. iswindows && alias tty="echo cmd.exe"
  127. type fortune >/dev/null 2>&1 && {
  128. fortune
  129. echo
  130. fortune -o
  131. echo
  132. }
  133. uname -a
  134. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  135. running $BASH $BASH_VERSION
  136. if test -n "$TMUX"
  137. then
  138. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  139. 2>/dev/null
  140. echo
  141. fi
  142. ###################################
  143. # some aliases and functions
  144. ( ! with_coreutils && isdarwin ) || test "$TERM" = dumb || \
  145. _coloroption=" --color=auto"
  146. ( ! with_coreutils && isdarwin ) || iswindows || \
  147. _timeoption=" --time-style=long-iso"
  148. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  149. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  150. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  151. _timeformat_num="%Y%m%d%H%M%S"
  152. alias datenum="date +$_timeformat_num"
  153. alias ls="ls -hCF${_coloroption}${_timeoption}"
  154. if ! with_coreutils
  155. then
  156. export LSCOLORS=gxfxcxdxbxegedabagacad
  157. alias ls="ls -G"
  158. fi
  159. # export GREP_OPTIONS=""
  160. alias gr="grep -n --color=always"
  161. iswindows && alias grep="grep -n"
  162. # alias ll="ls -l"
  163. # alias la="ls -A"
  164. # alias lla="ls -Al"
  165. alias less="less -F"
  166. null type emacs && alias em="emacs -nw"
  167. null type vim && alias vi=vim
  168. alias pstree="LANG=C pstree"
  169. alias cp="cp -v"
  170. alias mv="mv -v"
  171. alias rm="rm -v"
  172. alias psaux="ps auxww"
  173. alias q=exit
  174. null type e3em && alias e3=e3em
  175. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  176. alias po=popd
  177. alias pu=pushd
  178. null type sudo && alias sudo="sudo " # use aliases through sudo
  179. null type sudoedit && alias sudoe="sudoedit"
  180. null type halt && alias halt="sudo halt"
  181. null type reboot && alias reboot="sudo reboot"
  182. null type dbus-send && {
  183. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  184. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  185. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  186. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  187. }
  188. alias rand="echo \$RANDOM"
  189. null type file-roller && alias xunp="file-roller -h"
  190. null type paco && alias pc="sudo \paco -D"
  191. alias pycalc="python -i -c 'from math import *' "
  192. null type python3 && alias py3=python3
  193. null type python2 && alias py2=python2
  194. alias _reloadrc="test -f ~/.bashrc && source ~/.bashrc"
  195. # alias mytime="date +%Y%m%d-%H%M%S"
  196. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  197. # type trash >/dev/null 2>&1 && alias rm=trash
  198. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  199. null type xmms2 && alias xm="xmms2"
  200. #export PLAYER="mpg123 -C -v --title"
  201. null type screen && alias screen="screen -e^z^z"
  202. #alias zcd="cd \`zenity --file-selection --directory\`"
  203. null type gtags && alias gtags="gtags --verbose"
  204. null type htags && alias htags="htags --xhtml --symbol --line-number \
  205. --frame --alphabet --verbose"
  206. null type aunpack && alias au=aunpack
  207. null type lv && alias lv="lv|less"
  208. null type rsync && alias rs="rsync --progress --itemize-changes --compress"
  209. isdarwin && alias updatedb="LC_ALL=C updatedb"
  210. # do not use locate installed by macports
  211. isdarwin && test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  212. # pad
  213. alias pad=notepad
  214. null type gedit && alias pad=gedit
  215. null type leafpad && alias pad=leafpad
  216. isdarwin && alias pad="open -e"
  217. null type wicd-curses && alias wic=wicd-curses
  218. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  219. #alias wicn="wicd-cli -y -c -n"
  220. wicn(){
  221. if test $# -eq 0
  222. then
  223. local num
  224. wicd-cli -y -l | head
  225. echo -n "input num: "
  226. read num
  227. test -n "$num" && wicd-cli -y -c -n $num
  228. else
  229. wicd-cli -y -c -n $1
  230. fi
  231. }
  232. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  233. /usr/share/vim/vim73/macros/less.sh \
  234. /usr/share/vim/vim72/macros/less.sh
  235. do
  236. test -f $f && alias vl=$f && break
  237. done
  238. null type yaourt && alias yt=yaourt
  239. null type cower && alias cower="cower --color=auto"
  240. null type pacmatic && {
  241. alias pacman="pacmatic"
  242. export PACMAN="pacmatic"
  243. }
  244. _pacman_update_mirrorlist_with_reflector(){
  245. ml=/etc/pacman.d/mirrorlist
  246. cmd="$(expr "$(grep -m 1 reflector $ml)" : '# With: *\(.*\)')"
  247. if test -z "$cmd"
  248. then
  249. cmd="reflector --verbose -l 5 --sort rate --save $ml"
  250. fi
  251. echo "Running $cmd ..." 1>&2
  252. sudo $cmd
  253. }
  254. null type reflector && test -f /etc/pacman.d/mirrorlist && \
  255. alias reflect_mirrorlist=_pacman_update_mirrorlist_with_reflector
  256. null type apt-get && {
  257. alias aupgrade="sudo apt-get autoremove --yes && \
  258. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  259. alias aptin="apt-get install"
  260. alias aptsearch="apt-cache search"
  261. alias aptshow="apt-cache show"
  262. }
  263. null type port && {
  264. alias port="port -v"
  265. alias pupgrade="sudo port -v selfupdate && \
  266. { sudo port -v upgrade outdated; }"
  267. }
  268. if iscygwin; then
  269. null type windate || \
  270. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  271. # alias cygsu="cygstart /cygwinsetup.exe"
  272. # alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  273. fi
  274. g(){
  275. if test $# -eq 0 && null type git-info
  276. then
  277. git info
  278. else
  279. git "$@"
  280. fi
  281. }
  282. if null type _git && inbash
  283. then
  284. # enable programmable completion for g
  285. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  286. || complete -o default -o nospace -F _git g
  287. fi
  288. git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  289. null type gitmemo && alias m=gitmemo
  290. null type gitmemo && alias m=gitmemo
  291. alias setup.py="sudo python3 setup.py install --record files.txt"
  292. ssh(){
  293. __my_set_screen_title ssh
  294. command ssh "$@"
  295. }
  296. clk(){
  297. local tformat="%Y/%m/%d %H:%M:%S %z"
  298. cal
  299. REPLY=
  300. printf "\\r`date "+${tformat}"`"
  301. read -t 1
  302. while test $? -ne 0
  303. do
  304. printf "\\r`date "+${tformat}"`"
  305. read -t 1
  306. done
  307. }
  308. s(){
  309. if test $# -eq 0
  310. then
  311. echo "No search word given." 1>&2
  312. return 1
  313. fi
  314. if git rev-parse --git-dir >/dev/null 2>&1
  315. then
  316. git grep -n "$@"
  317. elif which ag >/dev/null 2>&1
  318. then
  319. ag --pager="$PAGER" "$@"
  320. elif which ack >/dev/null 2>&1
  321. then
  322. ack --pager="$PAGER" "$@"
  323. else
  324. grep -nH --exclude='.svn/*' --exclude='.git/*' "$@" -r . | $PAGER
  325. # echo "No search command found. Use grep." 2>&1
  326. # return 127
  327. fi
  328. }
  329. man(){
  330. env \
  331. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  332. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  333. LESS_TERMCAP_me=$(printf "\e[0m") \
  334. LESS_TERMCAP_se=$(printf "\e[0m") \
  335. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  336. LESS_TERMCAP_ue=$(printf "\e[0m") \
  337. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  338. man "$@"
  339. }
  340. scr(){
  341. test -n "$1" && pf="${1}-"
  342. local _tformat="%Y%m%d-%H%M%S%z"
  343. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  344. SCRIPT=${_file} script ${_file} "$@"
  345. }
  346. netwait(){
  347. while ! ping -c 1 -t 1 example.com
  348. do
  349. true
  350. done
  351. echo network works.
  352. }
  353. cd(){
  354. if test $# -eq 0
  355. then
  356. pushd ~/ >/dev/null
  357. elif test "$1" = -
  358. then
  359. local pwd="$PWD"
  360. command cd "$OLDPWD"
  361. pushd -n "$pwd" >/dev/null # stack last dir
  362. elif ! test -d "$1"
  363. then
  364. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  365. return 1
  366. else
  367. pushd "$1" >/dev/null
  368. fi
  369. __dirs_rm_dup "$PWD"
  370. echo "$PWD"
  371. }
  372. __dirs_rm_dup(){
  373. for d in "$@"
  374. do
  375. local next="$(__realpath --strip "$d")"
  376. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  377. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  378. do
  379. popd +$l -n >/dev/null
  380. done
  381. done
  382. }
  383. __realpath(){
  384. if type realpath >/dev/null 2>&1
  385. then
  386. command realpath "$@"
  387. else
  388. while ! test -d $1
  389. do
  390. shift
  391. done
  392. local d="$OLDPWD"
  393. command cd "$1"
  394. echo "$PWD"
  395. command cd "$d"
  396. fi
  397. }
  398. dh(){
  399. if test $# -eq 0
  400. then
  401. dirs -v -l
  402. else
  403. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  404. cd "$dir"
  405. fi
  406. }
  407. input(){
  408. local foo
  409. stty -echo
  410. read foo
  411. stty echo
  412. echo $foo
  413. }
  414. tmux(){
  415. if test $# -eq 0
  416. then
  417. (cd ~; command tmux start;)
  418. if command tmux has -t main
  419. then
  420. command tmux attach -t main
  421. else
  422. (cd ~; command tmux new -s main;)
  423. fi
  424. else
  425. command tmux "$@"
  426. fi
  427. }
  428. mcrypt-stream(){
  429. test $# -eq 2 || return 1
  430. case $1 in
  431. en)
  432. mcrypt --key $2 | base64 ;;
  433. de)
  434. base64 -d | mcrypt -d --key $2 ;;
  435. esac
  436. }
  437. gpg-stream(){
  438. test $# -eq 2 || return 1
  439. case $1 in
  440. en)
  441. gpg --passphrase $2 -c --batch |base64 ;;
  442. de)
  443. base64 -d|gpg --passphrase $2 -d --batch ;;
  444. esac
  445. }
  446. dgpg(){
  447. if test "$1" = help || test -z "$2"
  448. then
  449. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  450. return
  451. fi
  452. local srcs="$2"
  453. local dsts="$3"
  454. test -z "$dsts" && dsts="${srcs}.out"
  455. local pw
  456. echo -n "dgpg pw: "
  457. read -s pw
  458. echo ""
  459. test -z "$pw" && return 1
  460. for f in *${srcs}
  461. do
  462. local d="$(basename "$f" "${srcs}")${dsts}"
  463. echo -n "Processing $f to $d..."
  464. if test -d "$f"
  465. then
  466. echo "`printf 'failed (%s is directory)' $f`"
  467. elif test -f "$d"
  468. then
  469. echo "`printf 'failed (%s is already exists)' $d`"
  470. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  471. then
  472. echo "done"
  473. else
  474. echo "failed"
  475. test -f "$d" && rm "$d"
  476. fi
  477. done
  478. }
  479. alias enst="gpg-stream en"
  480. alias dest="gpg-stream de"
  481. showinfo(){
  482. echo "Japanese letters are 表示可能"
  483. __try_exec diskinfo
  484. ! isdarwin && test -n "${DISPLAY}" && {
  485. __try_exec xrandr | \grep --color=never ^Screen
  486. }
  487. iswindows || __try_exec finger $USER
  488. LANG=C __try_exec id
  489. __try_exec xset q
  490. }
  491. x(){
  492. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  493. #mkdir -p ~/.my/log
  494. # nohup startx >~/.my/log/xorg.log 2>&1 &
  495. # exit
  496. exec startx
  497. else
  498. echo "X cant be started! Another X is already running?" 1>&2
  499. fi
  500. }
  501. bak(){
  502. for file in "$@"
  503. do
  504. cp -v ${file} ${file}.bak
  505. done
  506. }
  507. di(){
  508. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  509. then
  510. local diffcmd=colordiff
  511. else
  512. local diffcmd=diff
  513. fi
  514. ${diffcmd} -u "$@" | ${PAGER}
  515. }
  516. tb(){
  517. local tb="$HOME/.my/tb"
  518. mkdir -p "$tb"
  519. for file in "$@"
  520. do
  521. mv -t "$tb" "$file"
  522. done
  523. }
  524. mkcd(){
  525. if test -z "$1"
  526. then
  527. echo "mkcd: usage: mkcd <dir>"
  528. return 1
  529. elif test -d "$1"
  530. then
  531. echo "Dir \"$1\" already exists."
  532. else
  533. mkdir -p "$1"
  534. echo "Dir \"$1\" created."
  535. fi
  536. cd "$1"
  537. }
  538. mkcdd(){
  539. # make and change date directory
  540. _d=`date +%Y%m%d-%H%M%S`
  541. mkcd "$_d"
  542. }
  543. if test -n "$TMUX" && null type reattach-to-user-namespace
  544. then
  545. alias pbpaste="reattach-to-user-namespace pbpaste"
  546. alias pbcopy="reattach-to-user-namespace pbcopy"
  547. fi
  548. catclip(){
  549. if iswindows
  550. then
  551. cat /dev/clipboard | tr -d \\r
  552. elif isdarwin
  553. then
  554. pbpaste
  555. else
  556. xclip -o -selection "clipboard"
  557. fi
  558. }
  559. setclip(){
  560. if test $# -eq 0
  561. then
  562. exec 3<&0
  563. else
  564. exec 3<<__EOF__
  565. `cat "$@"`
  566. __EOF__
  567. fi
  568. if iswindows
  569. then
  570. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  571. elif isdarwin
  572. then
  573. pbcopy 0<&3
  574. else
  575. 0<&3 xclip -i -f -selection "primary" | \
  576. xclip -i -f -selection "clipboard"
  577. fi
  578. exec 3<&-
  579. }
  580. open_file(){
  581. if iswindows
  582. then
  583. cmd.exe //c start "" "$@"
  584. elif isdarwin
  585. then
  586. touch "$@"
  587. open "$@"
  588. elif islinux
  589. then
  590. touch "$@"
  591. if null type pcmanfm; then
  592. LC_MESSAGES= pcmanfm "$@"
  593. else
  594. LC_MESSAGES= xdg-open "$@" &
  595. fi
  596. else
  597. cat "$@"
  598. fi
  599. }
  600. o(){
  601. if test $# -eq 0
  602. then
  603. open_file .
  604. else
  605. for f in "$@"
  606. do
  607. open_file "$(realpath "$f")"
  608. done
  609. fi
  610. }
  611. convmv-sjis2utf8-test(){
  612. convmv -r -f sjis -t utf8 *
  613. }
  614. convmv-sjis2utf8-notest(){
  615. convmv -r -f sjis -t utf8 * --notest
  616. }
  617. winln(){
  618. # for windose make link (actually junction)
  619. if test $# -eq 0
  620. then
  621. {
  622. echo "usage: winln TARGET LINK_NAME"
  623. echo "Create a link to TARGET with the name LINK_NAME \
  624. (that is, TARGET must already exist)."
  625. echo "About other features run 'junction'."
  626. } 1>&2
  627. return 1
  628. else
  629. junction "$2" "$1"
  630. fi
  631. }
  632. __my_moc_state(){
  633. type mocp >/dev/null 2>&1 || return
  634. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  635. printf "$1" "`mocp -Q %title 2>/dev/null`"
  636. }
  637. __my_parse_svn_branch() {
  638. local LANG=C
  639. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  640. local svn_repository_root=$(svn info 2>/dev/null | \
  641. sed -ne 's#^Repository Root: ##p')
  642. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  643. awk '{print $1}'
  644. }
  645. __my_svn_ps1(){
  646. if svn status >/dev/null 2>&1
  647. then
  648. local svn_branch=$(__my_parse_svn_branch)
  649. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  650. fi
  651. }
  652. __my_battery_status(){
  653. local dir=/sys/class/power_supply/BAT0
  654. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  655. test -r $dir/charge_now
  656. then
  657. local st=$(cat $dir/status)
  658. local full=$(cat $dir/charge_full)
  659. local now=$(cat $dir/charge_now)
  660. local rate=$(expr $now \* 100 / $full)
  661. printf "$1" "${st}:${rate}%"
  662. fi
  663. }
  664. alias bat='__my_battery_status %s\\n'
  665. ip-address(){
  666. type ip >/dev/null 2>&1 || return 1
  667. local ip=$(LANG=C ip addr show scope global | \
  668. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  669. test -n "$ip" && printf $1 $ip
  670. }
  671. test -n "$SCRIPT" && __my_ps1_script_str="${__my_c5}SCR${__my_cdef} "
  672. test -n "$SSH_CONNECTION" && __my_ps1_ssh_str="${__my_c5}SSH${__my_cdef} "
  673. __my_ps1_scale(){
  674. local last=$?
  675. printf "${LINES}x${COLUMNS}"
  676. return $last
  677. }
  678. __my_ps1_tmux(){
  679. local last=$?
  680. null type tmux || return $last
  681. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  682. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  683. return $last
  684. }
  685. __my_ps1_moc(){
  686. local last=$?
  687. __my_moc_state "[MOC:%s]"
  688. return $last
  689. }
  690. for f in /usr/share/git/git-prompt.sh \
  691. /opt/local/share/git-core/git-prompt.sh \
  692. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  693. do
  694. test -r $f && . $f && break
  695. done
  696. GIT_PS1_SHOWDIRTYSTATE=t
  697. GIT_PS1_SHOWUPSTREAM=t
  698. __my_ps1_git(){
  699. local last=$?
  700. null type __git_ps1 || return $last
  701. null __gitdir || return $last
  702. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  703. return $last
  704. }
  705. __my_ps1_ipaddr(){
  706. local last=$?
  707. ! iswindows && ip-address [Addr:%s]
  708. return $last
  709. }
  710. __my_ps1_bttry(){
  711. local last=$?
  712. local bst="${TMP}/batterystatus"
  713. if test -z "$DISPLAY" && ! iswindows
  714. then
  715. test -f $bst && local bstr="$(cat $bst)"
  716. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  717. echo "[Battery:$bstr]"
  718. __my_battery_status %s >$bst &
  719. fi
  720. return $last
  721. }
  722. __my_ps1_dirs(){
  723. dirs | wc -l
  724. }
  725. __my_ps1_jobs(){
  726. jobs | wc -l
  727. }
  728. if test "$TERM" != dumb
  729. then
  730. __my_c1="\[\e[0;33m\]" # color for PWD
  731. __my_c2="\[\e[0;36m\]" # color for user
  732. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  733. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  734. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;31m\]"
  735. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  736. else __my_c4="\[\e[1;32m\]" # color for ::
  737. fi
  738. __my_c5="\[\e[30;47m\]" # color for SCR
  739. __my_cdef="\[\e[0m\]"
  740. fi
  741. export _LAST_STATUS=$?
  742. __my_export_last_status(){
  743. export _LAST_STATUS=$?
  744. echo $_LAST_STATUS
  745. return $_LAST_STATUS
  746. }
  747. _ps1_bash="\
  748. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  749. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? $(__my_ps1_scale) \D{%T} ${__my_ps1_script_str}${__my_ps1_ssh_str}\$ "
  750. inbash && PS1=$_ps1_bash
  751. __my_set_screen_title(){
  752. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  753. then
  754. echo -ne "\033k$1\033\\"
  755. fi
  756. }
  757. __my_set_title(){
  758. case $TERM in
  759. (rxvt*|xterm*|aterm|screen*)
  760. title="$(echo $@)"
  761. test -t 1 &&
  762. test -n "$DISPLAY" &&
  763. test -z "$EMACS" &&
  764. echo -n -e "\033]0;${title}\007"
  765. ;;
  766. esac
  767. }
  768. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\:\${PWD};
  769. __my_set_screen_title \$(basename \"\$PWD\")/"